module PLM
  #
  #
  #
  module Model
    #
    # On construit une classe qui derive de ActiveLDAP qui recupere les informations des
    # Individus dans les laboratoires
    #
    class Emath < PLM::Model::EmathBackend
      ldap_mapping dn_attribute: 'cn',
      prefix: '',
      classes: [ 'organizationalPerson', 'inetOrgPerson', 'person', 'qmailUser']

      def initialize(mails)
        @persons = []
        mails.each do |mail|
          @persons += find_by_email(mail)
        end
        @persons.uniq!
      end
      def persons
        @persons
      end

      def descriptions
        description(true)
      end

      # def title
      #   attribute_present?('title') ? self.title : ''
      # end

      def modEmathProfile(vals)
        vals = [vals] unless vals.is_a?(Array)
        vals.each do |descHash|
          type=descHash["type"]
          descvalue=descHash["value"]
          newdesc=[]
          persons.each do |entry|
            if PLM::Model::EmathSup.exists?(entry.mail)
              sup=PLM::Model::EmathSupA.find(entry.mail)
              if sup.attribute_present?("description")
                if type=="title"
                  newdesc=sup.description(true).delete_if{ |desc| desc=~/^(M\.|Mme)$/i }
                else
                  newdesc=sup.description(true).delete_if{ |desc| desc=~/^\[AMS[0-9]+:/ }
                end
              end
            else
              sup=PLM::Model::EmathSup.new(entry.mail)
            end
            newdesc.push(descvalue) unless type=="title"&&descvalue=="_unset_"
            sup.description=newdesc
            unless sup.save
              return sup.errors.full_messages.to_s
            end
          end
          persons.each do |entry|
            if type=="title"
              if entry.attribute_present?("title")
                entry.title=nil
              end
              entry.title=descvalue unless descvalue=="_unset_"
            else
              if entry.attribute_present?("description")
                newdesc = entry.description(true).delete_if{ |desc| desc=~/^\[AMS[0-9]+:/ }
                newdesc.push(descvalue)
                entry.description = newdesc
              else
                entry.description = descvalue
              end
            end
            unless  entry.save
              return entry.errors.full_messages.to_s
            end
          end
          descvalue
        end
      end
      #class << self
      #
      # Retrouver une personne depuis ses différents mails
      #
      def find_by_email(mail)
        all(filter: [ :or, {mail: mail, mailAlternateAddress: mail} ])
      end
      #end
    end

    #
    # On construit une classe qui derive de ActiveLDAP qui recupere les informations à
    # customiser par les individus
    #
    class EmathSup < PLM::Model::EmathSupBackend
      ldap_mapping dn_attribute: 'cn',
      prefix: '',
      classes: [ 'organizationalRole']
    end

    class EmathOrg < PLM::Model::EmathBackend
      ldap_mapping dn_attribute: 'o',
      prefix: '',
      classes: [ 'organization', 'labeledURIObject', 'qmailUser', 'EmathLabo']

      class << self
        def get_org(org)
          first("destinationIndicator=#{org}")
        end
      end

      def to_hash
        {
          name: o,
          desc: description,
          organismes: businesscategory,
          id: destinationIndicator.to_i,
          modifyTimeStamp: emathmodifytimestampattribute,
          source: emathsourceurlattribute,
          param: (emathparamurlattribute if attribute_present?('emathparamurlattribute')),
          file: street,
          url: labeleduri,
          mail: mail
        }
      end
    end
  end
end
