module PLM
  #
  #
  #
  module Model
    #
    # On construit une classe qui derive de ActiveLDAP qui recupere les informations des
    # gestionnaires de laboratoire en read-write
    #
    # le "has_many":admins, creer un "accessor" pour l'objet Branch qui est calcule par une
    # jointure entre la clef "uniqueMember" et l'objet "Plm"
    #
    class EmathCorresp < PLM::Model::PlmBackend

      ldap_mapping dn_attribute: 'cn',
      prefix: 'ou=emath',
      classes: ['top', 'groupOfUniqueNames']
      has_many :corresps,
      class_name: 'PLM::Model::Plm',
      primary_key: 'dn',
      wrap: 'uniqueMember'

      def description
        attribute_present?('description') ? self[:description] : ''
      end
    end
  end
end
